<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Variant API</title>

    <link rel="stylesheet" href="/css/bootstrap.min.css">

</head>

<body class="bg-light">
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom">
        <a class="navbar-brand" href="#">Point of Sale</a>
    </nav>
    <div class="container-fluid">
        <div class="row" style="min-height: 93.8vh">
            <div class="col-md-2 bg-white shadow">
                <div class="list-group mt-3">
                    <a href="/category/index" class="list-group-item list-group-item-action">Category</a>
                    <a href="/variant/index" class="list-group-item list-group-item-action active">Variant</a>
                    <a href="/product/index" class="list-group-item list-group-item-action">Product</a>
                    <a href="/orderheader/index" class="list-group-item list-group-item-action">Order header</a>
                    <a href="/orderdetail/index" class="list-group-item list-group-item-action">Order detail</a>
                </div>
            </div>
            <div class="col-md-10">
                <div class="card mt-3">
                    <div class="card-body shadow">
                        <h2>Variant API</h2>
                        <p>
                            <button class="btn btn-primary" onclick="OpenList(0, 5)">Open List</button>
                            <button class="btn btn-primary" onclick="OpenForm()">Open Add Form</button>
                        </p>
                        <input class="form-control" type="text" placeholder="Search" onkeyup="SearchVariant(this.value)" autocomplete="off">
                        <div id="variantList"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script src="/js/jquery-3.5.1.min.js"></script>
    <script src="/js/bootstrap-bundle.min.js"></script>

    <script>
        function OpenList(currentPage, length) {
            $.ajax({
                url: '/api/variantmapped?page=' + currentPage + '&size=' + length,
                type: 'GET',
                contentType: 'application/json',
                success: function(data) {
                    let table = '<select class="custom-select mt-3" id="size" onchange="OpenList(0,this.value)">'
                    table += '<option value="3" selected>..</option>'
                    table += '<option value="5">5</option>'
                    table += '<option value="10">10</option>'
                    table += '<option value="15">15</option>'
                    table += '</select>'
                    table += '<table class="table table-hover">';
                    table += "<tr> <th width='10%' class='text-center'>#</th> <th>Variant Code</th> <th>Variant Name</th> <th>Category</th> <th>Action</th> </tr>"
                    for (let i = 0; i < data.variant.length; i++) {
                        table += "<tr>";
                        table += "<td class='text-center'>" + (i + 1) + "</td>";
                        table += "<td>" + data.variant[i].variantCode + "</td>";
                        table += "<td>" + data.variant[i].variantName + "</td>";
                        table += "<td>" + data.variant[i].category.categoryName + "</td>";
                        table += "<td><button class='btn btn-primary' value='" + data.variant[i].id + "' onclick='formEdit(this.value)'>Edit</button> <button class='btn btn-danger' value='" + data.variant[i].id + "' onclick='formDelete(this.value)'>Delete</button> </td>";
                        table += "</tr>";
                    }
                    table += "</table>";
                    table += "<br>"
                    table += '<nav aria-label="Page navigation">';
                    table += '<ul class="pagination">'
                    table += '<li class="page-item"><a class="page-link" onclick="OpenList(' + (data.currentPage - 1) + ',' + length + ')">Previous</a></li>'
                    let index = 1;
                    for (let i = 0; i < data.totalPages; i++) {
                        table += '<li class="page-item"><a id="pageslink" class="page-link" onclick="OpenList(' + i + ',' + length + ')">' + index + '</a></li>'
                        index++;
                    }
                    table += '<li class="page-item"><a class="page-link" onclick="OpenList(' + (data.currentPage + 1) + ',' + length + ')">Next</a></li>'
                    table += '</ul>'
                    table += '</nav>';
                    $('#variantList').html(table);
                }
            });
        }


        function OpenForm() {
            $.ajax({
                url: '/api/category',
                type: 'GET',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered"';
                    form += "<tr>";
                    form += "<td>Variant Code</td>";
                    form += '<td><input class="form-control" type ="text" id="variant_code"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Variant Name</td>";
                    form += '<td><input class="form-control" type ="text" id="variant_name"></td>';
                    form += "</tr>";
                    form += "<td>Category</td>";
                    form += "<td><select class='custom-select' id='category_id'";
                    for (let i = 0; i < data.length; i++) {
                        form += "<option value='" + data[i].id + "'>" + data[i].categoryName + "</option>";
                    }
                    form += "</select></td>";
                    form += "</tr>";
                    form += "<tr>";
                    form += '<td colspan="2"><button class="btn btn-primary" onclick = "SaveVariant(this.value)">Save</button></td>';
                    form += '</tr>';
                    form += "</table>"
                    $("#variantList").html(form);
                }
            });
        }

        function SaveVariant() {
            var formData = '{';
            formData += '"variantCode":"' + $('#variant_code').val() + '",';
            formData += '"variantName":"' + $('#variant_name').val() + '",';
            formData += '"categoryId":"' + $('#category_id').val() + '"';
            formData += '}';

            $.ajax({
                url: '/api/variant',
                type: 'post',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList(0, 5);
                }
            });
        }

        function formEdit(id) {
            $.ajax({
                url: '/api/variant/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered">';
                    form += "<tr>";
                    $.ajax({
                        url: '/api/category/',
                        type: 'GET',
                        contentType: 'application/json',
                        success: function(dataCategory) {

                            form += "<td>Category </td>"
                            form += "<td><select class='custom-select' id='category_id'>"
                            for (let i = 0; i < dataCategory.length; i++) {
                                if (dataCategory[i].id == data.categoryId) {
                                    selected = "selected"
                                } else {
                                    selected = ""
                                }
                                form += "<option value='" + dataCategory[i].id + "' " + selected + ">" + dataCategory[i].categoryName + "</option>"
                            }
                            form += "</select></td>";
                            form += "</tr>"
                            form += "<tr>";
                            form += "<td>Variant Code</td>";
                            form += "<td><input class='form-control' type='text' id='variant_code' value='" + data.variantCode + "'><input class='form-control' type='hidden' id='createdOn' value='" + data.createdOn + "'></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>Variant Name</td>";
                            form += "<td><input class='form-control' type='text' id='variant_name' value='" + data.variantName + "'><input class='form-control' type='hidden' id='createdBy' value='" + data.createdBy + "'></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += '<td colspan="2"><button class="btn btn-primary" value="' + data.id + '" onclick="UpdateVariant(this.value)">Save</button></td>';
                            form += '</tr>';
                            form += "</table>"
                            $('#variantList').html(form);
                        }
                    });
                }
            });
        }

        function UpdateVariant(id) {
            var formData = '{';
            formData += '"variantCode":"' + $('#variant_code').val() + '",';
            formData += '"variantName":"' + $('#variant_name').val() + '",';
            formData += '"categoryId":"' + $('#category_id').val() + '",';
            formData += '"createdBy":"' + $('#createdBy').val() + '",'
            formData += '"createdOn":"' + $('#createdOn').val() + '"'
            formData += '}';

            $.ajax({
                url: '/api/variant/' + id,
                type: 'put',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList(0, 5);
                }
            });
        }

        function formDelete(id) {
            $.ajax({
                url: '/api/variant/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    let form = '<table class="table table-bordered">';
                    form += "<tr>";
                    $.ajax({
                        url: '/api/category/',
                        type: 'GET',
                        contentType: 'application/json',
                        success: function(dataCategory) {

                            form += "<td>Category </td>"
                            form += "<td><select class='custom-select' id='category_id' disabled>"
                            for (let i = 0; i < dataCategory.length; i++) {
                                if (dataCategory[i].id == data.categoryId) {
                                    selected = "selected"
                                } else {
                                    selected = ""
                                }
                                form += "<option value='" + dataCategory[i].id + "' " + selected + ">" + dataCategory[i].categoryName + "</option>"
                            }
                            form += "</select></td>";
                            form += "</tr>"
                            form += "<tr>";
                            form += "<td>Variant Code</td>";
                            form += "<td><input class='form-control' type='text' id='variant_code' value='" + data.variantCode + "' disabled><input class='form-control' type='hidden' id='createdOn' value='" + data.createdOn + "'></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += "<td>Variant Name</td>";
                            form += "<td><input class='form-control' type='text' id='variant_name' value='" + data.variantName + "' disabled><input class='form-control' type='hidden' id='createdBy' value='" + data.createdBy + "'></td>"
                            form += "</tr>";
                            form += "<tr>";
                            form += '<td colspan="2"><button class="btn btn-danger" value="' + data.id + '" onclick="DeleteVariant(this.value)">Delete</button></td>';
                            form += '</tr>';
                            form += "</table>"
                            $('#variantList').html(form);
                        }
                    });
                }
            });
        }

        function DeleteVariant(id) {
            var formData = '{';
            formData += '"variantCode":"' + $('#variant_code').val() + '",';
            formData += '"variantName":"' + $('#variant_name').val() + '",';
            formData += '"categoryId":"' + $('#category_id').val() + '",';
            formData += '"createdBy":"' + $('#createdBy').val() + '",'
            formData += '"createdOn":"' + $('#createdOn').val() + '"'
            formData += '}';

            $.ajax({
                url: '/api/variant/' + id,
                type: 'delete',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList(0, 5);
                }
            });
        }

        function SearchVariant(request) {
            //console.log(request)

            if (request.length > 0) {
                $.ajax({
                    url: '/api/searchvariant/' + request,
                    type: 'GET',
                    contentType: 'application/json',
                    success: function(result) {
                        //console.log(result)
                        let table = '<table class="table table-hover">';
                        table += "<tr> <th width='10%' class='text-center'>#</th> <th>Variant Code</th> <th>Variant Name</th> <th>Category</th> <th>Action</th> </tr>"
                        if (result.length > 0) {
                            for (let i = 0; i < result.length; i++) {
                                table += "<tr>";
                                table += "<td class='text-center'>" + (i + 1) + "</td>";
                                table += "<td>" + result[i].variantCode + "</td>";
                                table += "<td>" + result[i].variantName + "</td>";
                                table += "<td>" + result[i].category.categoryName + "</td>";
                                table += "<td><button class='btn btn-primary' value='" + result[i].id + "' onclick='FormEdit(this.value)'>Edit</button> <button class='btn btn-danger' value='" + result[i].id + "' onclick='Delete(this.value)'>Delete</button> </td>";
                                table += "</tr>";
                            }
                        } else {
                            table += "<tr>";
                            table += "<td colspan='5' class='text-center'>No data</td>";
                            table += "</tr>";
                        }

                        table += "</table>";
                        $('#variantList').html(table);
                    }
                });
            } else {
                OpenList(0, 5);
            }
        }
    </script>